#include "seqUtil.h"
#include "Newickform.h"
#include <math.h>
#include <stdlib.h>





void combinetimepoints(newick_node *root)
{
	if (root->childNum==0)
	{
		root->nodebreak=0;
	}
	else
	{
		newick_child *child;

		child=root->child;
		
		while (child!=NULL)
		{
			combinetimepoints(child->node);
			if (child->node->childNum==0)
			{
				if (root->clusternumbers[child->node->timepoint]==0)
				{
					root->clusternumbers[child->node->timepoint]=child->node->clusternumbers[child->node->timepoint];
					newick_node *parent=root->parent;
					while (parent!=NULL)
					{
						if (parent->clusternumbers[child->node->timepoint]==0)
						{
							parent->clusternumbers[child->node->timepoint]=child->node->clusternumbers[child->node->timepoint];
						}
						parent=parent->parent;
					}
				}
				else
				{
					if (root->clusternumbers[child->node->timepoint]!=child->node->clusternumbers[child->node->timepoint])
					{
						root->nodebreak=1;
						
						newick_node *parent;
						parent=root->parent;
						while (parent!=NULL)
						{
							parent->nodebreak=1;
							
							parent=parent->parent;
						}
					}
				}
				
			}
			else if (child->node->childNum!=0)
			{
				int j;
				for (j=0; j<5;j++)
				{
					if (root->clusternumbers[j]!=child->node->clusternumbers[j])
					{
						if (root->clusternumbers[j]!=0 && child->node->clusternumbers[j]!=0)
						{
							root->nodebreak=1;
							
							newick_node *parent;
							parent=root->parent;
							while (parent!=NULL)
							{
								parent->nodebreak=1;
								
								parent=parent->parent;
							}
							if (root->clusternumbers[j]==0)
							{
								root->clusternumbers[j]=child->node->clusternumbers[j];
							}
						}
						
						
						if (root->clusternumbers[j]==0)
						{
							root->clusternumbers[j]=child->node->clusternumbers[j];
						}
					}
					
				}
			}

			
			child=child->next;
		}
		
		if (root->nodebreak!=1)
		{
			int h;
			for (h=0; h<5; h++)
			{
				root->clusternumbers[h]=0;
			}
			newick_child *childa;
			childa=root->child;
			while (childa!=NULL)
			{
				int p;
				for (p=0;p<5; p++)
				{
					if (childa->node->clusternumbers[p]!=0)
					{
						root->clusternumbers[p]=childa->node->clusternumbers[p];
					}
				}
				childa=childa->next;
			}
		}
	}
}


void makeChildrenSameCluster(newick_node *root)
{
	if (root->endingcluster==0 && root->parent!=NULL)
	{
		root->endingcluster=root->parent->endingcluster;
		
	}
	if (root->childNum==0)
	{
		
		if (root->endingcluster==0)
		{
			root->endingcluster=root->parent->endingcluster;
		}
	}
	else
	{
		newick_child *child;
		child=root->child;
		while (child!=NULL)
		{
			
			child->node->parent=root;
			makeChildrenSameCluster(child->node);
			
			child=child->next;
		}
	}
	
}



int combinenodes(newick_node *root, int cluster)
{
	
	root->endingcluster=cluster;
	
	int findclusternumbers[5];
	int previousclusternumberscount[5];
	int finalclusternumbers[5];
	int g;
	for (g=0; g<5; g++)
	{
		findclusternumbers[g]=0;
		previousclusternumberscount[g]=0;
		finalclusternumbers[g]=root->child->node->clusternumbers[g];
		findclusternumbers[g]=0;
	}
	newick_child *child;
	child=root->child;
	while (child!=NULL)
	{
		
		if (child->node->nodebreak==1)
		{
			cluster++;
			cluster=combinenodes(child->node, cluster);
		}
		
		int findclusternumbers2[5];
		for (g=0; g<5; g++)
		{
			findclusternumbers[g]=child->node->clusternumbers[g];
			findclusternumbers2[g]=0;
		}
		
		
		newick_child *child2;
		child2=root->child;
		while (child2!=NULL)
		{
			int f;
			for (f=0; f<5; f++)
			{
				if (child2->node->clusternumbers[g]==findclusternumbers[g])
				{
					findclusternumbers2[g]++;
				}
			}
			child2=child2->next;
		}
		int r;
		for (r=0; r<5; r++)
		{
			if (findclusternumbers2[r]>=previousclusternumberscount[r])
			{
				finalclusternumbers[r]=findclusternumbers[r];
				previousclusternumberscount[r]=findclusternumbers2[r];
			}
		}
		child=child->next;
		
	}
	child=root->child;
	while (child!=NULL)
	{
		if (child->node->dist==0)
		{
			finalclusternumbers[child->node->timepoint]=child->node->clusternumbers[child->node->timepoint];
		}
		if (child->node->nodebreak==1)
		{
			cluster++;
		}
		child=child->next;
	}
	
	int w;
	for (w=0; w<5; w++)
	{
		root->clusternumbers[w]=finalclusternumbers[w];
	}
	
	
	child=root->child;
	int combine=0;
	while (child!=NULL)
	{
		int u;
		for (u=0; u<5; u++)
		{
			if (root->clusternumbers[u]!=child->node->clusternumbers[u] && child->node->clusternumbers[u]!=0 && root->clusternumbers[u]!=0)
			{
				combine=1;
			}
			
		}
		child=child->next;
	}
	
	
	if (combine==0)
	{
		child=root->child;
		while (child!=NULL)
		{
			if (child->node->endingcluster!=0)
			{
				root->endingcluster=child->node->endingcluster;
				break;
			}
			child=child->next;
		}
	}

	child=root->child;
	while (child!=NULL)
	{
		
		int oneCluster=0;
		int t;
		for (t=0; t<5; t++)
		{
			if (child->node->clusternumbers[t]!=finalclusternumbers[t])
			{
				if (child->node->clusternumbers[t]!=0 && finalclusternumbers[t]!=0)
				{
					oneCluster=1;
				}
			}
		}
		if (oneCluster==0)
		{
			child->node->endingcluster=root->endingcluster;

			makeChildrenSameCluster(child->node);
		}
		else
		{
			cluster++;
			child->node->endingcluster=cluster;
			
			if (child->node->nodebreak!=1)
			{
				makeChildrenSameCluster(child->node);
			}
			
		}
		
		child=child->next;
	}
	
	
	
	return cluster;
}


int printFinalClustering (newick_node *root, int cluster, int present, FILE *j)
{
	newick_child *child;
	if (root->childNum == 0)
	{
		if (root->endingcluster==cluster)
		{
			fprintf(j,"%s, ", root->taxon);
			present=1;
		}
	}
	else
	{
		child = root->child;
		while (child != NULL)
		{
			
			present=printFinalClustering(child->node, cluster, present,j);
			
			child = child->next;
		}
	}
	return present;
}


int compare(newick_node *root, newick_node* other, int found)
{
	if (found==0)
	{
		if (root->childNum==0)
		{
			if (other->taxon!=NULL)
			{
				if (strcmp(root->taxon, other->taxon)==0)
				{
					root->timepoint=other->timepoint;
					int n;
					for (n=0; n<5; n++)
					{
						root->clusternumbers[n]=other->clusternumbers[n];
					}
					found=1;
				}
			}
			else
			{
				newick_child *otherchild;
				otherchild=other->child;
				while (otherchild!=NULL)
				{
					found=compare(root, otherchild->node, found);
					if (found==1)
					{
						break;
					}	
					otherchild=otherchild->next;
				}
			}
			
		}
		else
		{
			newick_child *rootchild;
			rootchild=root->child;
			while (rootchild!=NULL)
			{
				found=compare(rootchild->node, other, found);
				if (found==1)
				{
					break;
				}
				rootchild=rootchild->next;
			}
		}
	}
	return found;
}

int convertClustering(newick_node *root, newick_node *time0, newick_node *time1, newick_node *time2, newick_node *time3, newick_node *time4, int notcomplete)
{
	newick_child *child;
	if (root->childNum == 0)
	{
		int found=0;
		while (1)
		{
			if (time0!=NULL)
			{
				found=compare(root,time0, found);
				if (found==1)
				{
					break;
				}
			}
			if (time1!=NULL)
			{
				found=compare(root,time1, found);
				if (found==1)
				{
					break;
				}
			}
			if (time2!=NULL)
			{
				found=compare(root,time2, found);
				if (found==1)
				{
					break;
				}
			}
			if (time3!=NULL)
			{
				found=compare(root,time3, found);
				if (found==1)
				{
					break;
				}
			}
			if (time4!=NULL)
			{
				found=compare(root,time4, found);
				if (found==1)
				{
					break;
				}
			}
			if (found==0)
			{
				printf("Name %s in combined file does not match any from individual time point files.\n", root->taxon);
				notcomplete=1;
				break;
			}
			
		}
		
	}
	else
	{
		child = root->child;
		
		while (child != NULL)
		{
			
			notcomplete=convertClustering(child->node, time0, time1, time2, time3, time4, notcomplete);
			
			child = child->next;
		}
	}
	return notcomplete;
}



/*
 *  CombineTimePoints.c
 *  
 *
 *  Created by Lily Blair on 4/19/12.
 *  Copyright 2012 Yale University. All rights reserved.
 *
 */


