#include "seqUtil.h"
#include "Newickform.h"
#include <math.h>


#define STR_OUT	"TMP"

newick_node* analyzeTimePoint (char *pcInputFile, int timepoint, FILE *j)
{
	int iLen, iMaxLen;
	char *pcTreeStr;
	newick_node *root;
	newick_node *newroot;
	newick_node *newnewroot;
	char acStrArray[256];
	float Threshold;
	int TFBranch=0;
	int binary;
	int items_read;
	float L;
	int numbranch;
	int u;

	rerootReturn *rerootBranch;
	rerootReturn *rerootBranch2;
	fReturn *farray;

		
	
	
	FILE *f;
	FILE *g;
	FILE *h;
	
	// Initialize memory management procedure
	seqMemInit();
	
	
	// Open tree file
	f = fopen(pcInputFile, "r+");
	if (f == NULL)
	{
		printf("Cannot open input file. Please check file name again.\n");
		seqFreeAll();
		exit(-1);
	}
	// Read in tree string
	pcTreeStr = NULL;
	iLen = 0;
	iMaxLen = 0;
	while (1)
	{
		memset(acStrArray, '\0', sizeof(acStrArray));
		char format[10];
		if (sizeof acStrArray > 0 && sizeof acStrArray < 65535)
			sprintf(format,"%%%us",(unsigned)sizeof acStrArray-1);
		else {
			fprintf(stderr,"Fix me!!!\n");
			exit(1);
		}
		
		fscanf(f, format, acStrArray);
		if (acStrArray[0] == '\0' && feof(f))
		{
			break;
		}
		inputString(acStrArray, &pcTreeStr, &iLen, &iMaxLen);
	}
	fclose(f);
	
	root = parseTree(pcTreeStr);
	
	printf("Enter 1 if data is in binary, 0 if it is multifurcating.\n");
	
	items_read = scanf ("%i", &binary);
	
	if (binary==1)
	{
		
		
		g= fopen(pcInputFile, "w+");
		if (g == NULL)
		{
			printf("Cannot open output file. Please check file name again.\n");
			seqFreeAll();
			exit(-1);
		}
		//root->dist=0;
		printTree(root, g);
		//fprintf(g,"):0.0;");
		fclose(g);
		//root->dist=-1;
		
		
		
		// Open tree file
		h = fopen(pcInputFile, "r+");
		if (h == NULL)
		{
			printf("Cannot open input file. Please check file name again.\n");
			seqFreeAll();
			exit(-1);
		}
		// Read in tree string
		pcTreeStr = NULL;
		iLen = 0;
		iMaxLen = 0;
		while (1)
		{
			memset(acStrArray, '\0', sizeof(acStrArray));
			char format[10];
			if (sizeof acStrArray > 0 && sizeof acStrArray < 65535)
				sprintf(format,"%%%us",(unsigned)sizeof acStrArray-1);
			else {
				fprintf(stderr,"Fix me!!!\n");
				exit(1);
			}
			
			fscanf(h, format, acStrArray);
			if (acStrArray[0] == '\0' && feof(f))
			{
				break;
			}
			inputString(acStrArray, &pcTreeStr, &iLen, &iMaxLen);
		}
		fclose(h);
		
		root = parseTree(pcTreeStr);
		
	}
	int mutation;
	printf("\nEnter the number of sequences in data set.\n");
	scanf ("%d",&numbranch);
	printf("Enter the average number of nucleotides per sequence in data set.\n");
	scanf ("%f",&L);
	printf("Enter maximum number of shared mutations.\n");
	scanf("%f", &Threshold);
	//Threshold=Threshold/2;
	printf("Enter maximum possible mutations.\n");
	scanf("%d", &mutation);
	//mutation=rint(mutation/2);
	farray = malloc (sizeof *farray);
	if (farray==NULL)
	{
		fprintf(stderr, "Malloc Problem Fix Me\n");
		exit(9);
	}	
	farray->TFBranch=0;
	farray->farray =malloc (sizeof *farray->farray);
	if (farray->farray==NULL)
	{
		fprintf(stderr, "Malloc Problem Fix Me\n");
		exit(9);
	}
	

	for (u=0;u<(numbranch+1);u++)
	{
		farray->farray[u] =malloc (sizeof(int));
		if (farray->farray==NULL)
		{
			fprintf(stderr, "Malloc Problem Fix Me\n");
			exit(9);
		}
		farray->farray[u]=0;
	}
	newroot=root;
	FindNumElements(newroot);
	AverageBranch(newroot);
	rerootBranch=findLongestBranch(newroot,NULL);
	if (rerootBranch!=NULL)	
	{
		int reroottimes=1;
		
		while ((reroottimes<numbranch) && rerootBranch!=NULL)
		{	
			float rerootBranch2dist;
			int rerootBranch2childnum;
			char *rerootBranch2taxon;
			if (rerootBranch->longestbranch->node->childNum>0)
			{
				rerootBranch2=findLongestBranch(rerootBranch->longestbranch->node,NULL);
				rerootBranch2dist=rerootBranch2->longestbranch->node->dist;
				rerootBranch2taxon=rerootBranch2->longestbranch->node->taxon;
				rerootBranch2childnum=rerootBranch2->longestbranch->node->childNum;
				
			}
			else
			{
				rerootBranch2dist=0;
				rerootBranch2taxon=NULL;
			}
			
			rerootBranch->longestbranch->node->cluster=1;
			
			AverageBranch(newroot);
			
			rerootBranch->longestbranch->node->cluster=0;
			
						
			if ((rerootBranch->longestbranch->node->totaldistance > newroot->totaldistance) && (rerootBranch2taxon!=NULL || rerootBranch2childnum!=0))
			{

				newick_child *newn = malloc (sizeof *newn);
				if (newn==NULL)
				{
					fprintf(stderr, "Malloc Problem Fix Me\n");
					exit(10);
				}
				newnewroot=changeRoot(newroot,newn,rerootBranch);
				AverageBranch(newnewroot);
				rerootBranch=findLongestBranch(newnewroot,rerootBranch);

				reroottimes++;
				
				
				newroot=newnewroot;
				
			}
			else
			{
				break;
			}
			
			
			
			
		}
		
		
	}
	
	FindNumElements(newroot);
	
	int timepointcluster=1;
	timepointcluster=CountClusters(newroot, farray, Threshold, L, mutation, timepoint, timepointcluster);
	
	TFBranch=0;

	if (newroot->cluster!=1)
	{
		farray->farray[newroot->numElements]++;
		if (newroot->numElements!=0)
		{
			printTaxon(newroot,timepoint, timepointcluster);
			
			
			if ((newroot->possibleroothere==1 || newroot->childNum==0) && newroot->numElements!=0)
			{
				newroot->roothere=1;
			}

		}
		else 
		{
			newroot->timepoint=timepoint;
		}

	}
	
	for (u=1;u<(numbranch+1);u++)
	{
		TFBranch=TFBranch+farray->farray[u];
	}
	
	
	int numroots=0;

	
	
	numroots=checknumberofroots(newroot, numroots,1,1,j);
	
	
	int correct=1;
	correct=checkpositionofroots(newroot, correct, L);
	fprintf(j, "TIMEPOINT %i:\n", (timepoint +1));
	
	makePrintedZero(newroot);
	numroots=checknumberofroots(newroot,1,1,2,j);
	numroots=numroots-1;
	timepoint++;
	fprintf(j, "\nTHERE ARE %i CLUSTERS IN TIMEPOINT %i.\n", numroots, timepoint);
	fprintf(j, "\n\n");
	printf("\nTHERE ARE %i CLUSTERS IN TIMEPOINT %i.\n\n", numroots, timepoint);
	
	
	return newroot;
}

newick_node* analyzeCombinedTree (char *pcInputFile, int timepoint)
{
	int iLen, iMaxLen;
	char *pcTreeStr;
	
	newick_node *root;
	newick_node *newroot;
	newick_node *newnewroot;
	char acStrArray[256];
	int binary;
	int items_read;
	float L;
	int numbranch;
	int u;
	rerootReturn *rerootBranch;
	rerootReturn *rerootBranch2;
	fReturn *farray;
	
	
	FILE *f;
	FILE *g;
	FILE *h;
	// Initialize memory management procedure
	seqMemInit();
	
	// Open tree file
	f = fopen(pcInputFile, "r+");
	if (f == NULL)
	{
		printf("Cannot open input file. Please check file name again.\n");
		seqFreeAll();
		exit(-1);
	}
	// Read in tree string
	pcTreeStr = NULL;
	iLen = 0;
	iMaxLen = 0;
	while (1)
	{
		memset(acStrArray, '\0', sizeof(acStrArray));
		char format[10];
		if (sizeof acStrArray > 0 && sizeof acStrArray < 65535)
			sprintf(format,"%%%us",(unsigned)sizeof acStrArray-1);
		else {
			fprintf(stderr,"Fix me!!!\n");
			exit(1);
		}
		
		fscanf(f, format, acStrArray);
		if (acStrArray[0] == '\0' && feof(f))
		{
			break;
		}
		inputString(acStrArray, &pcTreeStr, &iLen, &iMaxLen);
	}
	fclose(f);
	
	root = parseTree(pcTreeStr);
	
	printf("Enter 1 if data is in binary, 0 if it is multifurcating.\n");
	
	items_read = scanf ("%i", &binary);
	
	if (binary==1)
	{
		
		
		g= fopen(pcInputFile, "w+");
		if (g == NULL)
		{
			printf("Cannot open output file. Please check file name again.\n");
			seqFreeAll();
			exit(-1);
		}

		printTree(root, g);

		fclose(g);
		
		
		
		// Open tree file
		h = fopen(pcInputFile, "r+");
		if (h == NULL)
		{
			printf("Cannot open input file. Please check file name again.\n");
			seqFreeAll();
			exit(-1);
		}
		// Read in tree string
		pcTreeStr = NULL;
		iLen = 0;
		iMaxLen = 0;
		while (1)
		{
			memset(acStrArray, '\0', sizeof(acStrArray));
			char format[10];
			if (sizeof acStrArray > 0 && sizeof acStrArray < 65535)
				sprintf(format,"%%%us",(unsigned)sizeof acStrArray-1);
			else {
				fprintf(stderr,"Fix me!!!\n");
				exit(1);
			}
			
			fscanf(h, format, acStrArray);
			if (acStrArray[0] == '\0' && feof(f))
			{
				break;
			}
			inputString(acStrArray, &pcTreeStr, &iLen, &iMaxLen);
		}
		fclose(h);
		
		root = parseTree(pcTreeStr);
		
	}
	newick_child *newn = malloc (sizeof *newn);
	if (newn==NULL)
	{
		fprintf(stderr, "Malloc Problem Fix Me\n");
		exit(10);
	}
	printf("\nEnter the number of sequences in data set.\n");
	scanf ("%d",&numbranch);
	printf("Enter the average number of nucleotides per sequence in data set.\n");
	scanf ("%f",&L);
		
	farray = malloc (sizeof *farray);
	if (farray==NULL)
	{
		fprintf(stderr, "Malloc Problem Fix Me\n");
		exit(9);
	}
	farray->TFBranch=0;
	farray->farray =malloc (sizeof *(farray->farray));
	if (farray->farray==NULL)
	{
		fprintf(stderr, "Malloc Problem Fix Me\n");
		exit(9);
	}
	
	
	for (u=0;u<(numbranch+1);u++)
	{
		farray->farray[u] =malloc (sizeof(int));
		if (farray->farray==NULL)
		{
			fprintf(stderr, "Malloc Problem Fix Me\n");
			exit(9);
		}
		farray->farray[u]=0;
	}
	newroot=root;
	FindNumElements(newroot);
	AverageBranch(newroot);
	root->dist=0;
	rerootBranch=findLongestBranch(newroot,NULL);
	if (rerootBranch!=NULL)	
	{
		int reroottimes=1;
		
		while ((reroottimes<numbranch) && rerootBranch!=NULL)
		{	
			float rerootBranch2dist;
			int rerootBranch2childnum;
			char *rerootBranch2taxon;
			if (rerootBranch->longestbranch->node->childNum>0)
			{
				rerootBranch2=findLongestBranch(rerootBranch->longestbranch->node,NULL);
				rerootBranch2dist=rerootBranch2->longestbranch->node->dist;
				rerootBranch2taxon=rerootBranch2->longestbranch->node->taxon;
				rerootBranch2childnum=rerootBranch2->longestbranch->node->childNum;
				
			}
			else
			{
				rerootBranch2dist=0;
				rerootBranch2taxon=NULL;
			}
			
			rerootBranch->longestbranch->node->cluster=1;
			
			AverageBranch(newroot);
			
			rerootBranch->longestbranch->node->cluster=0;
			
			AverageBranch(rerootBranch->longestbranch->node);
			
			
			
			if ((rerootBranch->longestbranch->node->totaldistance > newroot->totaldistance) && (rerootBranch2taxon!=NULL || rerootBranch2childnum!=0))
			{
				newick_child *newn = malloc (sizeof *newn);
				if (newn==NULL)
				{
					fprintf(stderr, "Malloc Problem Fix Me\n");
					exit(10);
				}
				newnewroot=changeRoot(newroot,newn,rerootBranch);
				AverageBranch(newnewroot);
				rerootBranch=findLongestBranch(newnewroot,rerootBranch);
				
				reroottimes++;
				
				
				
				
				newroot=newnewroot;
				
			}
			else
			{
				break;
			}
			
			
			
			
		}
		
		
	}
	
	
	
	
	
	
	return newroot;
}


