#include "seqUtil.h"
#include "Newickform.h"
#include <math.h>

int main ()
{
	
	char OutputFile[200]="treeoutput.txt";
	printf("Enter name of output file.\n");
	scanf("%s",OutputFile);
	
	
	int timepoints;
	printf("\nEnter the number of time points in data set.  Should be 5 or less.\n");
	scanf ("%d",&timepoints);
	
	char FILE_NAME[200];
	char FILE_NAME1[200];
	char FILE_NAME2[200];
	char FILE_NAME3[200];
	char FILE_NAME4[200];
	char FILE_NAME5[200];
	
	
	
	
	newick_node *newroot0=NULL;
	newick_node *newroot1=NULL;
	newick_node *newroot2=NULL;
	newick_node *newroot3=NULL;
	newick_node *newroot4=NULL;
	newick_node *root;

	FILE *j;
	j= fopen(OutputFile, "w+");
	if (j == NULL)
	{
		printf("Cannot open output file. Please check file name again.\n");
		seqFreeAll();
		exit(-1);
	}

	if (timepoints>=1)
	{
		
		printf("Enter name of tree file 1.\n");
		scanf("%s",FILE_NAME);
		newroot0= analyzeTimePoint(FILE_NAME,0,j);
	}
	if (timepoints>=2)
	{
		printf("Enter name of tree file 2.\n");
		scanf("%s",FILE_NAME1);
		newroot1= analyzeTimePoint(FILE_NAME1,1,j);
	}
	if (timepoints>=3)
	{
		printf("Enter name of tree file 3.\n");
		scanf("%s",FILE_NAME2);
		newroot2= analyzeTimePoint(FILE_NAME2,2,j);
	}
	if (timepoints>=4)
	{
		printf("Enter name of tree file 4.\n");
		scanf("%s",FILE_NAME3);
		newroot3= analyzeTimePoint(FILE_NAME3,3,j);
	}
	if (timepoints>=5)
	{
		printf("Enter name of tree file 5.\n");
		scanf("%s",FILE_NAME4);
		newroot4= analyzeTimePoint(FILE_NAME4,4,j);
	}
	
	if (timepoints>1)
	{
	
		printf("Enter name of combined time point tree file.\n");
		scanf("%s",FILE_NAME5);
		
		root=analyzeCombinedTree(FILE_NAME5, 6);
		int notcomplete;
		notcomplete=convertClustering(root, newroot0, newroot1, newroot2, newroot3, newroot4, 0);
		
		if (notcomplete==1)
		{
			fprintf(stderr, "Fix files so that names match.\n");
			exit(-1);
		}
		
		combinetimepoints(root);
		int totalcluster=1;
		totalcluster=combinenodes(root,totalcluster);

		
		printf("\n\nCOMBINED TREE:\n");
		fprintf(j,"\n\nCOMBINED TREE:\n");

		int o;
		int finalcluster=0;
		int present=0;
		for (o=0; o<totalcluster+1; o++)
		{
			present=printFinalClustering(root, o, 0, j);
			if (present==1)
			{
				finalcluster++;
				fprintf(j," are in cluster %i.\n", finalcluster);
			}
		}
	
		printf("THERE ARE %i CLUSTERS IN THE COMBINED TREE.\n\n\n", finalcluster);
		fprintf(j,"THERE ARE %i CLUSTERS IN THE COMBINED TREE.\n", finalcluster);

		fclose(j);
	}
	
	return 0;
}